#
#	Mini Message Handler
#	Makefile for source release [for X680x0 GCC+libc only]
#

SHELL	= fish -f
ARCH	= MSDOS
CC	= gcc
CC_FLAG	= -O
#CC_FLAG	= -g -DDEBUG
BIN_DIR	= C:/USR/LOCAL/BIN/MMH
MAN_DIR	= C:/USR/LOCAL/MAN
LIBS	= -ldos -lmb
ESPX	= -ldos -liocs -lmb -lxnetwork -lnetwork -lioctl
STRIP	= strip
#STRIP	= touch
RM	= rm
RM_FLAG	= -f
INSTALL	= 

VERSION		= 2.20
NET_OPT		= -DMSPL -DPOP3
CONF_OPT	= -DMIME -DSUPPORT_X0201 -DDISPLAY_CTRL

SRC_DIR		= ../src
COMPAT_DIR	= ../compat
TCP_DIR		= ../tcplib
POP3_DIR	= ../pop3lib
KANJI_DIR	= ../kanjilib
TERM_DIR	= ../termlib
MIME_DIR	= ../mimelib
DOC_DIR		= ../doc
ETC_DIR		= ../etc
ARC_DIR		= mmh-${VERSION}
BUILD_DIR	= .

COMPAT_INC	= ${COMPAT_DIR}/compat.h
COMPAT_SRC	= ${COMPAT_DIR}/compat.c
TCP_INC		= ${TCP_DIR}/field.h \
		${TCP_DIR}/tcplib.h \
		${TCP_DIR}/inetbios.h
TCP_SRC		= ${TCP_DIR}/tcplib.c \
		${TCP_DIR}/inetbios.c
POP3_INC	= ${POP3_DIR}/pop3lib.h
POP3_SRC	= ${POP3_DIR}/pop3lib.c
KANJI_INC	= ${KANJI_DIR}/kanjilib.h
#		${KANJI_DIR}/kanjiext.h
KANJI_SRC	= ${KANJI_DIR}/kanjilib.c
#		${KANJI_DIR}/kanjiext.c
TERM_INC	= ${TERM_DIR}/termlib.h
TERM_SRC	= ${TERM_DIR}/termlib.c \
		${TERM_DIR}/termdos.c
MIME_INC	= ${MIME_DIR}/mimelib.h
MIME_SRC	= ${MIME_DIR}/mimelib.c
INC_FLAG	= -I. -I${COMPAT_DIR} -I${TCP_DIR} -I${POP3_DIR} -I${KANJI_DIR} -I${MIME_DIR} -I${TERM_DIR} -I${SRC_DIR}
CPP_FLAG	= -D${ARCH} -DMMH -DX68K
C_FLAG		= ${CPP_FLAG} ${CC_FLAG} ${INC_FLAG} ${CONF_OPT}

SRC		= ${COMPAT_SRC} \
		${TCP_SRC} \
		${POP3_SRC} \
		${KANJI_SRC} \
		${TERM_SRC} \
		${MIME_SRC} \
		${SRC_DIR}/ali.c \
		${SRC_DIR}/folder.c \
		${SRC_DIR}/inc.c \
		${SRC_DIR}/inst_mmh.c \
		${SRC_DIR}/mark.c \
		${SRC_DIR}/mhparam.c \
		${SRC_DIR}/mhpath.c \
		${SRC_DIR}/msgchk.c \
		${SRC_DIR}/packf.c \
		${SRC_DIR}/pick.c \
		${SRC_DIR}/refile.c \
		${SRC_DIR}/rmf.c \
		${SRC_DIR}/rmm.c \
		${SRC_DIR}/scan.c \
		${SRC_DIR}/show.c \
		${SRC_DIR}/sortm.c \
		${SRC_DIR}/mmh_subr.c \
		${SRC_DIR}/mmh_fild.c
INC		= ${COMPAT_INC} \
		${TCP_INC} \
		${POP3_INC} \
		${KANJI_INC} \
		${TERM_INC} \
		${MIME_INC} \
		${SRC_DIR}/mmh.h
MAN		= ${DOC_DIR}/ali.doc \
		${DOC_DIR}/folder.doc \
		${DOC_DIR}/folders.doc \
		${DOC_DIR}/inc.doc \
		${DOC_DIR}/inst_mmh.doc \
		${DOC_DIR}/mark.doc \
		${DOC_DIR}/mhparam.doc \
		${DOC_DIR}/mhpath.doc \
		${DOC_DIR}/msgchk.doc \
		${DOC_DIR}/next.doc \
		${DOC_DIR}/packf.doc \
		${DOC_DIR}/pick.doc \
		${DOC_DIR}/prev.doc \
		${DOC_DIR}/refile.doc \
		${DOC_DIR}/rmf.doc \
		${DOC_DIR}/rmm.doc \
		${DOC_DIR}/scan.doc \
		${DOC_DIR}/show.doc \
		${DOC_DIR}/sortm.doc
DOC1		= ${DOC_DIR}/readme.doc \
		${DOC_DIR}/update.doc
DOC2		= ${ETC_DIR}/readme.X68 \
		${ETC_DIR}/readme.dos \
		${ETC_DIR}/mmh.bm
MAKE		= Makefile.src Makefile.X68 Makefile.B16 Makefile.B32 \
		convert.bat
EXE		= ali.x folder.x inc.x inst_mmh.x mark.x \
		mhparam.x mhpath.x msgchk.x packf.x pick.x \
		refile.x rmf.x rmm.x scan.x show.x sortm.x \
		inc_p.x msgchk_p.x
DUP		= folders.x next.x prev.x
OBJ		= ali.o folder.o inc.o inst_mmh.o mark.o \
		mhparam.o mhpath.o msgchk.o packf.o \
		pick.o refile.o rmf.o rmm.o scan.o \
		show.o sortm.o \
		compat.o mmh_subr.o mmh_fild.o mimelib.o kanjilib.o \
		pop3lib.o tcplib.o termdos.o inc_p.o msgchk_p.o \
		inetbios.o
SRC_DIST	= mmh_src.Lzh
REL_DIST	= mmh_rel.Lzh
EXE_DIST	= mmh_exe.Lzh

all: ${EXE}

obj: ${OBJ}

ali.x: ali.o mmh_subr.o mmh_fild.o mimelib.o kanjilib.o
	${CC} ${C_FLAG} -o $@ ali.o mmh_subr.o mmh_fild.o mimelib.o \
				kanjilib.o ${LIBS}
	${STRIP} $@

folder.x: folder.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ folder.o mmh_subr.o ${LIBS}
	${STRIP} $@

folders.x: folder.x
	COPY folder.x folders.x

inc.x: inc.o compat.o mmh_subr.o mmh_fild.o mimelib.o kanjilib.o
	${CC} ${C_FLAG} -o $@ inc.o compat.o mmh_subr.o mmh_fild.o \
				mimelib.o kanjilib.o ${LIBS}
	${STRIP} $@

inst_mmh.x: inst_mmh.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ inst_mmh.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

mark.x: mark.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ mark.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

mhparam.x: mhparam.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ mhparam.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

mhpath.x: mhpath.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ mhpath.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

msgchk.x: msgchk.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ msgchk.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

next.x: show.x
	COPY show.x next.x

packf.x: packf.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ packf.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

pick.x: pick.o compat.o mmh_subr.o mmh_fild.o mimelib.o kanjilib.o
	${CC} ${C_FLAG} -o $@ pick.o compat.o mmh_subr.o mmh_fild.o \
				mimelib.o kanjilib.o ${LIBS}
	${STRIP} $@

prev.x: show.x
	COPY show.x prev.x

refile.x: refile.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ refile.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

rmf.x: rmf.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ rmf.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

rmm.x: rmm.o compat.o mmh_subr.o
	${CC} ${C_FLAG} -o $@ rmm.o compat.o mmh_subr.o ${LIBS}
	${STRIP} $@

scan.x: scan.o compat.o mmh_subr.o mimelib.o mmh_fild.o kanjilib.o
	${CC} ${C_FLAG} -o $@ scan.o compat.o mmh_subr.o mmh_fild.o \
				mimelib.o kanjilib.o ${LIBS}
	${STRIP} $@

show.x: show.o compat.o mmh_subr.o mmh_fild.o mimelib.o kanjilib.o
	${CC} ${C_FLAG} -o $@ show.o compat.o mmh_subr.o mmh_fild.o \
				mimelib.o kanjilib.o ${LIBS}
	${STRIP} $@

sortm.x: sortm.o compat.o mmh_subr.o mmh_fild.o mimelib.o \
				kanjilib.o
	${CC} ${C_FLAG} -o $@ sortm.o compat.o mmh_subr.o mmh_fild.o \
				mimelib.o kanjilib.o ${LIBS}
	${STRIP} $@

inc_p.x: inc_p.o compat.o mmh_subr.o mmh_fild.o mimelib.o \
	kanjilib.o pop3lib.o tcplib.o termdos.o
	${CC} ${C_FLAG} -o $@ inc_p.o compat.o mmh_subr.o mmh_fild.o \
				mimelib.o kanjilib.o pop3lib.o tcplib.o \
				termdos.o ${ESPX}
	${STRIP} $@

msgchk_p.x: msgchk_p.o compat.o mmh_subr.o mmh_fild.o mimelib.o \
		kanjilib.o pop3lib.o tcplib.o termdos.o
	${CC} ${C_FLAG} -o $@ msgchk_p.o compat.o mmh_subr.o mmh_fild.o \
				mimelib.o kanjilib.o pop3lib.o \
				tcplib.o termdos.o ${ESPX}
	${STRIP} $@

compat.o: ${COMPAT_INC} ${COMPAT_DIR}/compat.c
	${CC} ${C_FLAG} -c ${COMPAT_DIR}/compat.c

tcplib.o: ${COMPAT_INC} ${TCP_INC} ${TCP_DIR}/tcplib.c
	${CC} ${C_FLAG} ${NET_OPT} -c ${TCP_DIR}/tcplib.c

inetbios.o: ${COMPAT_INC} ${TCP_INC} ${TCP_DIR}/inetbios.c
	${CC} ${C_FLAG} ${NET_OPT} -c ${TCP_DIR}/inetbios.c

pop3lib.o: ${COMPAT_INC} ${TCP_INC} ${POP3_INC} ${POP3_DIR}/pop3lib.c
	${CC} ${C_FLAG} ${NET_OPT} -c ${POP3_DIR}/pop3lib.c

kanjilib.o: ${COMPAT_INC} ${KANJI_INC} ${KANJI_DIR}/kanjilib.c
	${CC} ${C_FLAG} -DDELETE_X0212 -c ${KANJI_DIR}/kanjilib.c

#kanjiext.o: ${COMPAT_INC} ${KANJI_INC} ${KANJI_DIR}/kanjiext.c
#	${CC} ${C_FLAG} -DDELETE_X0212 -c ${KANJI_DIR}/kanjiext.c

#termlib.o: ${COMPAT_INC} ${TERM_INC} ${TERM_DIR}/termlib.c
#	${CC} ${C_FLAG} -c ${TERM_DIR}/termlib.c

termdos.o: ${COMPAT_INC} ${TERM_INC} ${TERM_DIR}/termdos.c
	${CC} ${C_FLAG} -c ${TERM_DIR}/termdos.c

mimelib.o: ${COMPAT_INC} ${MIME_INC} ${MIME_DIR}/mimelib.c
	${CC} ${C_FLAG} -c ${MIME_DIR}/mimelib.c

ali.o: ${INC} ${SRC_DIR}/ali.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/ali.c

folder.o: ${INC} ${SRC_DIR}/folder.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/folder.c

inc.o: ${INC} ${SRC_DIR}/inc.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/inc.c

inst_mmh.o: ${INC} ${SRC_DIR}/inst_mmh.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/inst_mmh.c

mark.o: ${INC} ${SRC_DIR}/mark.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/mark.c

mhparam.o: ${INC} ${SRC_DIR}/mhparam.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/mhparam.c

mhpath.o: ${INC} ${SRC_DIR}/mhpath.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/mhpath.c

msgchk.o: ${INC} ${SRC_DIR}/msgchk.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/msgchk.c

packf.o: ${INC} ${SRC_DIR}/packf.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/packf.c

pick.o: ${INC} ${SRC_DIR}/pick.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/pick.c

refile.o: ${INC} ${SRC_DIR}/refile.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/refile.c

rmf.o: ${INC} ${SRC_DIR}/rmf.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/rmf.c

rmm.o: ${INC} ${SRC_DIR}/rmm.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/rmm.c

scan.o: ${INC} ${SRC_DIR}/scan.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/scan.c

show.o: ${INC} ${SRC_DIR}/show.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/show.c

sortm.o: ${INC} ${SRC_DIR}/sortm.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/sortm.c

mmh_subr.o: ${INC} ${SRC_DIR}/mmh_subr.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/mmh_subr.c

mmh_fild.o: ${INC} ${SRC_DIR}/mmh_fild.c
	${CC} ${C_FLAG} -c ${SRC_DIR}/mmh_fild.c

inc_p.o: ${INC} ${SRC_DIR}/inc.c
	${CC} ${C_FLAG} ${NET_OPT} -o inc_p.o -c ${SRC_DIR}/inc.c

msgchk_p.o: ${INC} ${SRC_DIR}/msgchk.c
	${CC} ${C_FLAG} ${NET_OPT} -o msgchk_p.o -c ${SRC_DIR}/msgchk.c

help:
	@echo "--- Mini Message Handler Makefile ---"
	@echo "make          --- make executable file"
	@echo "make install  --- install executable & manual file"
	@echo "make clean    --- remove backup & object file"
	@echo "make remove   --- remove object file"
	@echo "make help     --- print help message"
	@echo "make src_dist --- archive source & document file (develop)"
	@echo "make rel_dist --- archive source & document file (release)"
	@echo "make bin_dist --- archive executable & document file"

install: all
	COPY ali.x ${BIN_DIR}
	COPY folder.x ${BIN_DIR}
	COPY folders.x ${BIN_DIR}
	COPY inc.x ${BIN_DIR}
	COPY inst_mmh.x ${BIN_DIR}
	COPY mark.x ${BIN_DIR}
	COPY mhparam.x ${BIN_DIR}
	COPY mhpath.x ${BIN_DIR}
	COPY msgchk.x ${BIN_DIR}
	COPY next.x ${BIN_DIR}
	COPY packf.x ${BIN_DIR}
	COPY pick.x ${BIN_DIR}
	COPY prev.x ${BIN_DIR}
	COPY refile.x ${BIN_DIR}
	COPY rmf.x ${BIN_DIR}
	COPY rmm.x ${BIN_DIR}
	COPY scan.x ${BIN_DIR}
	COPY show.x ${BIN_DIR}
	COPY sortm.x ${BIN_DIR}
	COPY inc_p.x ${BIN_DIR}
	COPY msgchk_p.x ${BIN_DIR}
	COPY ${DOC_DIR}/*.doc ${MAN_DIR}

clean:
	-${RM} ${RM_FLAG} ${EXE}
	-${RM} ${RM_FLAG} ${DUP}
	-${RM} ${RM_FLAG} ${OBJ}
	-${RM} ${RM_FLAG} *~
	-${RM} ${RM_FLAG} \#*
	-${RM} ${RM_FLAG} *\#

remove:
	-${RM} ${RM_FLAG} ${OPTCFG}
	-${RM} ${RM_FLAG} ${EXE}
	-${RM} ${RM_FLAG} ${DUP}
	-${RM} ${RM_FLAG} ${OBJ}

src_dist:
	-${RM} ${RM_FLAG} ${SRC_DIST}
	lha a ${SRC_DIST} ${ARC_DIR}/compat \
			${ARC_DIR}/tcplib ${ARC_DIR}/pop3lib \
			${ARC_DIR}/kanjilib ${ARC_DIR}/termlib \
			${ARC_DIR}/mimelib ${ARC_DIR}/src \
			${ARC_DIR}/doc ${ARC_DIR}/etc

rel_dist:
	-${RM} ${RM_FLAG} ${REL_DIST}
	lha a ${REL_DIST} ${ARC_DIR}/compat \
			${ARC_DIR}/tcplib ${ARC_DIR}/pop3lib \
			${ARC_DIR}/kanjilib ${ARC_DIR}/termlib \
			${ARC_DIR}/mimelib ${ARC_DIR}/src \
			${ARC_DIR}/doc

bin_dist: ${EXE}
	-${RM} ${RM_FLAG} ${EXE_DIST}
	lha a ${EXE_DIST} ${ARC_DIR}/build ${ARC_DIR}/doc
