/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Alias command
 *  File        : ali.c
 *  Version     : 2.19
 *  First Edit  : 1995-04/23
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
char	alias_file[PATH_BUFF];		/* ꥢե	*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"alias",		FILE_MASK},
  {"list",		0},
  {"nolist",		0},
#ifdef	notdef
  {"normalize",		0},
  {"nonormalize",	0},
  {"user",		0},
  {"nouser",		0},
#endif	/* notdef */
};
static char		ali_opt[SMALL_BUFF];
static struct cpy_hdr	ali_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {MH_ALIAS_FIELD,	alias_file,	sizeof(alias_file)},
  {"aliopt:",		ali_opt,	sizeof(ali_opt)},
};

static int	expand_alias();			/* ꥢŸ	*/
static void	print_alias();			/* ꥢɽ	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  FILE		*fp;
  int		status;
  int		i, j;
  int		f_flag = 0;
  int		l_flag = 0;
  int		n_flag = 0;
  int		u_flag = 0;
  int		alias = 0;
  char		*ptr, *ptr2;
  char		buff[PATH_BUFF];
  char		recipient[ALIAS_BUFF];

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(ali_option, sizeof(ali_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }
  if (alias_file[0]) {
    f_flag = 1;
  }
  strcpy(buff, alias_file);
  ptr = buff;
  if ((*ptr == '/') && (!(isalpha(*ptr) && (*(ptr + 1) == ':')))) {
    strcpy(alias_file, ptr);
  } else {
    sprintf(alias_file, "%s/%s", mh_path, ptr);
  }

  /*
   * åβ
   */

  ptr2 = ali_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[switches] aliases",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -alias	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      if ((*ptr == '/') && (!(isalpha(*ptr) && (*(ptr + 1) == ':')))) {
		strcpy(alias_file, ptr);
	      } else {
		sprintf(alias_file, "%s/%s", mh_path, ptr);
	      }
	    } else {
	      print_fatal("Alias file does not specified.");
	      exit(1);
	    }
	    f_flag = 1;
	    break;
	  case 2:	/* -list	*/
	    l_flag = 1;
	    break;
	  case 3:	/* -nolist	*/
	    l_flag = 0;
	    break;
	  case 4:	/* -normalize	*/
	    n_flag = 1;
	    break;
	  case 5:	/* -nonormalize	*/
	    n_flag = 0;
	    break;
	  case 6:	/* -user	*/
	    u_flag = 1;
	    break;
	  case 7:	/* -nouser	*/
	    u_flag = 0;
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  if (!f_flag) {
    exit(0);
  }
  fp = fopen(alias_file, "r");
  if (fp == (FILE*)NULL) {
    print_fatal("Can't open alias file \"%s\".", alias_file);
    exit(1);
  }
  status = 0;
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  if (option[j].mode) {
	    i++;
	  }
	  break;
	}
      }
    } else {
      if (expand_alias(fp, recipient, ptr, sizeof(recipient)) > 0) {
	status = 1;
      }
      print_alias(recipient, l_flag);
      alias++;
    }
  }
  if (!alias) {
    while (!feof(fp)) {
      if (expand_alias(fp, recipient, (char*)NULL, sizeof(recipient)) > 0) {
	status = 1;
      }
      if (*recipient) {
	print_alias(recipient, l_flag);
      }
    }
  }
  fclose(fp);
  exit(status);
}

/*
 * ꥢŸ
 */

static int	expand_alias(fp, recipient, alias, number)
     FILE	*fp;
     char	*recipient;
     char	*alias;
     int	number;
{
  static int	level = 0;		/* alias level */
  char		buff1[BUFF_SIZE];
  char		buff2[BUFF_SIZE];
  char		*ptr1, *ptr2, *ptr3;
  int		next, match, first;
  int		status;
  unsigned long	position;

  if ((number <= 0) || (level >= 15)) {
    return(1);		/* alias loop or too long alias list */
  }
  if (alias) {
    strcpy(recipient, alias);
  } else {
    *recipient = '\0';
  }
  level++;
  status = -1;
  while (fgets(buff1, sizeof(buff1), fp)) {
    next = 0;
    ptr1 = buff1;
    while (*ptr1) {
      if ((*ptr1 == '\\') && (*(ptr1 + 1) == '\n')) {
	*ptr1 = '\0';
	next = 1;
	break;
      }
      if (*ptr1 == '\n') {
	*ptr1 = '\0';
	break;
      }
      ptr1++;
    }
    ptr1 = buff1;
    if ((!*ptr1) || (*ptr1 == '#')) {
      continue;
    }
    if ((*ptr1 == '\t') || (*ptr1 == ' ')) {
      continue;
    }
    match = 0;
    if (!alias) {
      ptr3 = ptr1;
      while (*ptr1) {
	if ((*ptr1 == '\t') || (*ptr1 == ' ')) {
	  continue;
	} else if (*ptr1 == ':') {
	  *ptr1++ = '\0';
	  alias = ptr3;
	  printf("%s: ", ptr3);
	  match = 1;
	  break;
	}
	ptr1++;
      }
    } if (!strncasecmp(ptr1, alias, strlen(alias))) {
      ptr1 += strlen(alias);
      if (*ptr1 == ':') {
	ptr1++;
	match = 2;
      }
    }
    if (match) {
      status = 0;
      first = 1;
      while (*ptr1) {
	if ((*ptr1 == '\t') || (*ptr1 == ' ')) {
	  ptr1++;
	} else {
	  ptr2 = ptr1;
	  ptr1 = get_real_adrs(ptr1, buff2);
	  if (first) {
	    first = 0;
	  } else {
	    *recipient++ = ',';
	    *recipient++ = ' ';
	    number -= 2;
	  }
	  *recipient = '\0';
	  
	  /*
	   * alias ¿Ÿå
	   */
	  
	  position = ftell(fp);
	  if (match == 1) {
	    strcpy(recipient, ptr2);
	  } else if (expand_alias(fp, recipient, buff2, number)) {
	    strcpy(recipient, ptr2);
	  }
	  fseek(fp, position, 0);
	  while (*recipient) {
	    recipient++;
	    number--;
	  }
	}
	if ((!*ptr1) && next) {
	  next = 0;
	  if (fgets(buff1, sizeof(buff1), fp)) {
	    ptr1 = buff1;
	    while (*ptr1) {
	      if ((*ptr1 == '\\') && (*(ptr1 + 1) == '\n')) {
		*ptr1 = '\0';
		next = 1;
		break;
	      }
	      if (*ptr1 == '\n') {
		*ptr1 = '\0';
		break;
	      }
	      ptr1++;
	    }
	    ptr1 = buff1;
	  } else {
	    break;
	  }
	}
      }
      break;
    }
  }
  level--;
  return(status);
}

/*
 * ꥢɽ
 */

static void	print_alias(ptr1, l_flag)
     char	*ptr1;
     int	l_flag;
{
  int	width;
  char	buff1[BUFF_SIZE];
  char	buff2[BUFF_SIZE];
  char	*ptr2, *ptr3;

  width = 0;
  ptr2 = buff1;
  while (*ptr1) {
    ptr3 = ptr1;
    ptr1 = get_real_adrs(ptr1, buff2);
    while (*ptr3) {
      *ptr2++ = *ptr3++;
      width++;
    }
    if (!l_flag) {
      if (*ptr1) {
	*ptr2++ = ',';
	width++;
      }
    }
    if (l_flag || (width >= (MAX_FIELD_COLUMN - 8))) {
      *ptr2 = '\0';
      printf("%s\n", buff1);
      width = 0;
      ptr2 = buff1;
      if (!l_flag) {
	*ptr2++ = ' ';
	width++;
      }
    } else {
      if (*ptr1) {
	*ptr2++ = ' ';
      }
    }
  }
  *ptr2 = '\0';
  if ((width > 0) &&
      (!((width == 1) && ((buff1[0] == ' ') || buff1[0] == '\t')))) {
    printf("%s\n", buff1);
  }
}
