/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Folder command
 *  File        : folder.c
 *  Version     : 2.19
 *  First Edit  : 1994-05/14
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",	0},
  {"pack",	0},
  {"nopack",	0},
  {"recurse",	0},
  {"norecurse",	0},
  {"push",	0},
  {"pop",	0},
  {"fast",	0},
  {"nofast",	0},
  {"create",	0},
  {"nocreate",	0},
  {"header",	0},
  {"noheader",	0},
};
static char		folder_perm[SMALL_BUFF];
static char		folder_opt[SMALL_BUFF];
static struct cpy_hdr	folder_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {MH_F_PERM_FIELD,	folder_perm,	sizeof(folder_perm)},
  {"folderopt:",	folder_opt,	sizeof(folder_opt)},
};

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  struct stat	stat_buff;
  int		status;
  int		current;
  int		i, j;
  int		c_flag = 0;
  int		f_flag = 0;
  int		h_flag = -1;
  int		p_flag = 0;
  int		r_flag = 0;
  int		s_flag = 0;
  int		t_flag = 0;
  int		flags;
  int		perm;
  char		buff1[PATH_BUFF];
  char		buff2[PATH_BUFF];
  char		*ptr, *ptr2, *ptr3;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }
  if (!strncasecmp(prog_name, FOLDERS_COMMAND, strlen(FOLDERS_COMMAND))) {
    h_flag = s_flag = 1;
  }

  /*
   * ե졼
   */

  if (get_environ(folder_option, sizeof(folder_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  /*
   * åβ
   */

  ptr2 = folder_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [msg] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -pack	*/
	    p_flag = 1;
	    break;
	  case 2:	/* -nopack	*/
	    p_flag = 0;
	    break;
	  case 3:	/* -recurse	*/
	    r_flag = 1;
	    break;
	  case 4:	/* -norecurse	*/
	    r_flag = 0;
	    break;
	  case 5:	/* -push	*/
	    if (t_flag) {
	      if (*folder_stack) {
		strcat(folder_stack, " ");
	      }
	      strcat(folder_stack, target_folder);
	    } else {
	      print_fatal("Folder does not specified.");
	      exit(1);
	    }
	    break;
	  case 6:	/* -pop		*/
	    ptr = folder_stack;
	    *target_folder = '\0';
	    ptr3 = (char*)NULL;
	    while (*ptr) {
	      ptr3 = ptr;
	      while ((*ptr == ' ') || (*ptr == '\t')) {
		ptr++;
	      }
	      if (*ptr < ' ') {
		break;
	      }
	      ptr2 = target_folder;
	      while (*ptr > ' ') {
		*ptr2++ = *ptr++;
	      }
	      *ptr2 = '\0';
	    }
	    if (*target_folder) {
	      t_flag = 1;
	      if (ptr3 != (char*)NULL) {
		*ptr3 = '\0';
	      }
	    } else {
	      print_fatal("folder stack empty.");
	      exit(1);
	    }
	    break;
	  case 7:	/* -fast	*/
	    f_flag = 1;
	    break;
	  case 8:	/* -nofast	*/
	    f_flag = 0;
	    break;
	  case 9:	/* -create	*/
	    c_flag = 1;
	    break;
	  case 10:	/* -nocreate	*/
	    c_flag = -1;
	    break;
	  case 11:	/* -header	*/
	    h_flag = 1;
	    break;
	  case 12:	/* -noheader	*/
	    h_flag = 0;
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr != '+') && (*ptr != '-') && (*ptr != '/')) {
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (target_number) {
    qsort(target_ptr, target_number, sizeof(int), int_compare);
    if (target_number > 1) {
      print_fatal("Only one message at a time!, continuing...");
    }
  } else if (p_flag) {
    add_message(current);
  }
  if (check_folder(target_folder) && (c_flag >= 0)) {
    if ((c_flag > 0) || yes_or_no("Create folder \"%s\"? ", target_folder)) {
      sprintf(buff1, "%s/%s", mh_path, target_folder);
      perm = get_protect(folder_perm);
      if (perm < 0) {
	perm = S_IEXEC | S_IREAD | S_IWRITE;
      }
      if (create_folder(target_folder, perm)) {
        print_fatal("Can't create folder %s.", target_folder);
        exit(1);
      }
      p_flag = 0;
      t_flag = 1;
    } else {
      exit(1);
    }
  }
  status = 0;
  if (p_flag) {
    s_flag = 0;
    for (i = 0; i < message_number; i++) {
      if ((i + 1) != message_ptr[i]) {
	sprintf(buff1, "%s/%s/%d", mh_path, target_folder, message_ptr[i]);
	sprintf(buff2, "%s/%s/%d", mh_path, target_folder, i + 1);
	if (!stat(buff2, &stat_buff)) {
	  print_fatal("Can't pack message %d.", message_ptr[i]);
	  status = 1;
	  break;
	}
	if (rename(buff1, buff2)) {
	  print_fatal("Can't pack message %d.", message_ptr[i]);
	  status = 1;
	  break;
	}
	if (target_number) {
	  if (message_ptr[i] == target_ptr[0]) {
	    set_current(target_folder, i + 1);
	  }
	}
      }
    }
    target_number = 0;
  } else {
    if (target_number) {
      if (check_message(target_folder, target_ptr[0])) {
	print_fatal("Message %d does not exist.", target_ptr[0]);
	exit(1);
      }
    }
  }
  i = j = 0;
  flags = (f_flag << 1) | r_flag;
  if (h_flag == -1) {
    h_flag = r_flag;
  }
  if (h_flag) {
    printf("\t\tFolder      # of messages (  range  ); cur  msg  (other files)\n");
  }
  if (s_flag) {
    if (t_flag) {
      if (print_folders(target_folder, flags, &i, &j)) {
	status = 1;
      }
    } else {
      if (print_folders((char*)NULL, flags, &i, &j)) {
	status = 1;
      }
    }
    if (!f_flag) {
      printf("\n\t\t     TOTAL=%5d messages in %d folders.\n", i, j);
    }
  } else {
    if (print_folder(target_folder, flags, &i, &j)) {
      status = 1;
    }
  }
  if (!status) {
    if (t_flag) {
      set_context(target_folder, folder_stack);
    }
    if (target_number) {
      set_current(target_folder, target_ptr[0]);
    }
  }
  exit(status);
}
