/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Pack folder command
 *  File        : packf.c
 *  Version     : 2.19
 *  First Edit  : 1994-08/17
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"file",		FILE_MASK},
};
static char		msg_perm[SMALL_BUFF];
static char		packf_opt[SMALL_BUFF];
static struct cpy_hdr	packf_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {MH_M_PERM_FIELD,	msg_perm,	sizeof(msg_perm)},
  {"packfopt:",		packf_opt,	sizeof(packf_opt)},
};

static int	pack_message();		/* åѥå	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  int		status;
  int		current;
  int		i, j;
  char		*ptr, *ptr2;
  char		target_file[PATH_BUFF];

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(packf_option, sizeof(packf_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  sprintf(target_file, "./%s", MH_PACK_FILE);

  /*
   * åβ
   */

  ptr2 = packf_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [msg] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -file	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      strcpy(target_file, ptr);
	    } else {
	      print_fatal("Destination file does not specified.");
	      exit(1);
	    }
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  if (option[j].mode) {
	    i++;
	  }
	  break;
	}
      }
    } else if (*ptr != '+') {
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  status = 0;
  if (!target_number) {
    target_number = message_number;
    target_ptr = message_ptr;
  }
  if (!target_number) {
    print_fatal("No messages in %s.", target_folder);
    exit(1);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  for (i = 0; i < target_number; i++) {
    if (pack_message(target_folder, target_file, target_ptr[i])) {
      status = 1;
      break;
    }
  }
  exit(status);
}

/*
 * åѥå
 */

static int	pack_message(folder_name, target_file, number)
     char	*folder_name;
     char	*target_file;
     int	number;
{
  struct stat	stat_buff;
  FILE		*fp1;
  FILE		*fp2;
  char		buff[BUFF_SIZE];
  int		perm;
  int		status = 0;
  
  sprintf(buff, "%s/%s/%d", mh_path, folder_name, number);
  fp1 = fopen(buff, "r");
  if (fp1 == (FILE*)NULL) {
    return(1);
  }
  fp2 = (FILE*)NULL;
  status = 0;
  if (stat(target_file, &stat_buff)) {
    if (yes_or_no("Create file \"%s\"? ", target_file)) {
      fp2 = fopen(target_file, "w");
      if (fp2 != (FILE*)NULL) {
	perm = get_protect(msg_perm);
	if (perm < 0) {
	  perm = S_IREAD | S_IWRITE;
	}
	chmod(target_file, perm);
      } else {
	print_fatal("Can't create file %s.", target_file);
	status = 1;
      }
    } else {
      status = 1;
    }
  } else {
    fp2 = fopen(target_file, "a");
    if (fp2 == (FILE*)NULL) {
      print_fatal("Can't open file %s.", target_file);
      status = 1;
    }
  }
  if (fp2) {
    fprintf(fp2, "%s\n", PACK_HEADER);
    while (fgets(buff, sizeof(buff), fp1)) {
      fputs(buff, fp2);
    }
    fprintf(fp2, "%s\n", PACK_HEADER);
    fclose(fp2);
  }
  fclose(fp1);
  return(status);
}
